package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type CentralKitchenForSchoolPackageWithDayDb struct {
	Db        *xorm.Engine `json:"db"`
	PackageId int          `json:"package_id"`
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) Set(packageId int) { // set方法
	centralKitchenForSchoolPackageWithDayDb.Db = Db
	centralKitchenForSchoolPackageWithDayDb.PackageId = packageId
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) GetCentralKitchenForSchoolPackageWithDay(id int) (m *model.CentralKitchenForSchoolPackageWithDay, err error) {
	m = new(model.CentralKitchenForSchoolPackageWithDay)
	has, err := centralKitchenForSchoolPackageWithDayDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) FindCentralKitchenForSchoolPackageWithDay() (*[]model.CentralKitchenForSchoolPackageWithDay, error) {
	var m []model.CentralKitchenForSchoolPackageWithDay
	if err := centralKitchenForSchoolPackageWithDayDb.Db.Where("package_id =?", centralKitchenForSchoolPackageWithDayDb.PackageId).Asc("id").Find(&m); err != nil {
		return nil, logx.Error(err)
	}
	return &m, nil
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) CentralKitchenForSchoolPackageWithDayInsert(m *model.CentralKitchenForSchoolPackageWithDay) (int, error) {
	_, err := centralKitchenForSchoolPackageWithDayDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) BatchAddCentralKitchenForSchoolPackageWithDaysBySession(session *xorm.Session, mm []*model.CentralKitchenForSchoolPackageWithDay) (int64, error) {
	affected, err := session.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) BatchAddCentralKitchenForSchoolPackageWithDays(mm []*model.CentralKitchenForSchoolPackageWithDay) (int64, error) {
	affected, err := centralKitchenForSchoolPackageWithDayDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) CentralKitchenForSchoolPackageWithDayDeleteBySession(session *xorm.Session) (int64, error) {
	return Db.Where("package_id = ?", centralKitchenForSchoolPackageWithDayDb.PackageId).Delete(model.CentralKitchenForSchoolPackageWithDay{})
}

func (centralKitchenForSchoolPackageWithDayDb *CentralKitchenForSchoolPackageWithDayDb) CentralKitchenForSchoolPackageWithDayUpdate(Db *xorm.Engine, id interface{}, m *model.CentralKitchenForSchoolPackageWithDay, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
