package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type CentralKitchenForSchoolUserRefundDayDb struct {
	Db        *xorm.Engine `json:"db"`
	RecordsId int          `json:"records_id"`
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) Set(recordsId int) { // set方法
	centralKitchenForSchoolUserRefundDayDb.Db = Db
	centralKitchenForSchoolUserRefundDayDb.RecordsId = recordsId
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) GetCentralKitchenForSchoolUserRefundDay(id int) (m *model.CentralKitchenForSchoolUserRefundDay, err error) {
	m = new(model.CentralKitchenForSchoolUserRefundDay)
	has, err := centralKitchenForSchoolUserRefundDayDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) FindCentralKitchenForSchoolUserRefundDay() (*[]model.CentralKitchenForSchoolUserRefundDay, error) {
	var m []model.CentralKitchenForSchoolUserRefundDay
	if err := centralKitchenForSchoolUserRefundDayDb.Db.Where("records_id =?", centralKitchenForSchoolUserRefundDayDb.RecordsId).Desc("id").Find(&m); err != nil {
		return nil, logx.Error(err)
	}
	return &m, nil
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) FindCentralKitchenForSchoolUserRefundDayByUid(uid int) (*[]model.CentralKitchenForSchoolUserRefundDay, error) {
	var m []model.CentralKitchenForSchoolUserRefundDay
	if err := centralKitchenForSchoolUserRefundDayDb.Db.Where("uid =?", uid).Desc("id").Find(&m); err != nil {
		return nil, logx.Error(err)
	}
	return &m, nil
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) CentralKitchenForSchoolUserRefundDayInsert(m *model.CentralKitchenForSchoolUserRefundDay) (int, error) {
	_, err := centralKitchenForSchoolUserRefundDayDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) BatchAddCentralKitchenForSchoolUserRefundDays(mm []*model.CentralKitchenForSchoolUserRefundDay) (int64, error) {
	affected, err := centralKitchenForSchoolUserRefundDayDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) CentralKitchenForSchoolUserRefundDayDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.CentralKitchenForSchoolUserRefundDay{})
	} else {
		return Db.Where("id = ?", id).Delete(model.CentralKitchenForSchoolUserRefundDay{})
	}
}

func (centralKitchenForSchoolUserRefundDayDb *CentralKitchenForSchoolUserRefundDayDb) CentralKitchenForSchoolUserRefundDayUpdate(id interface{}, m *model.CentralKitchenForSchoolUserRefundDay, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = centralKitchenForSchoolUserRefundDayDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = centralKitchenForSchoolUserRefundDayDb.Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

type CentralKitchenForSchoolUserRefundDayWithCentralKitchenForSchoolUserWithDay struct {
	model.CentralKitchenForSchoolUserRefundDay `xorm:"extends"`
	model.CentralKitchenForSchoolUserWithDay   `xorm:"extends"`
}

func (CentralKitchenForSchoolUserRefundDayWithCentralKitchenForSchoolUserWithDay) TableName() string {
	return "central_kitchen_for_school_user_refund_day"
}

type CentralKitchenForSchoolUserRefundDayWithData struct {
	model.CentralKitchenForSchoolUserRefundDay `xorm:"extends"`
	model.CentralKitchenForSchoolUserWithDay   `xorm:"extends"`
	model.CentralKitchenForSchoolPackageOrd    `xorm:"extends"`
	model.UserIdentity                         `xorm:"extends"`
	model.ClassWithUser                        `xorm:"extends"`
	model.Enterprise                           `xorm:"extends"`
	model.Class                                `xorm:"extends"`
	model.Grade                                `xorm:"extends"`
	model.User                                 `xorm:"extends"`
}

func (CentralKitchenForSchoolUserRefundDayWithData) TableName() string {
	return "central_kitchen_for_school_user_refund_day"
}

type CentralKitchenForSchoolUserWithDayWithCentralKitchenForSchoolUserRefundDay struct {
	model.CentralKitchenForSchoolUserWithDay   `xorm:"extends"`
	model.CentralKitchenForSchoolUserRefundDay `xorm:"extends"`
}

func (CentralKitchenForSchoolUserWithDayWithCentralKitchenForSchoolUserRefundDay) TableName() string {
	return "central_kitchen_for_school_user_with_day"
}
